﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.model
{
    public class Answer_option
    {
        //attributes
        private string idOption;
        private string event_code;
        private int object_id;
        private string option_text;
        private string consequence_code;

        //getters and setters
        public string IdOption { get => idOption; set => idOption = value; }
        public string Event_code { get => event_code; set => event_code = value; }
        public int Object_id { get => object_id; set => object_id = value; }
        public string Option_text { get => option_text; set => option_text = value; }
        public string Consequence_code { get => consequence_code; set => consequence_code = value; }


        //constructor

        public Answer_option()
        {
        }

        public Answer_option(string idOption, string event_code, int object_id, string option_text, string consequence_code)
        {
            this.idOption = idOption;
            this.event_code = event_code;
            this.object_id = object_id;
            this.option_text = option_text;
            this.consequence_code = consequence_code;
        }

        //equals
        public override bool Equals(object obj)
        {
            return obj is Answer_option option &&
                   idOption == option.idOption &&
                   event_code == option.event_code;
        }

        //hashcode
        public override int GetHashCode()
        {
            var hashCode = 1991354646;
            hashCode = hashCode * -1521134295 + EqualityComparer<string>.Default.GetHashCode(idOption);
            hashCode = hashCode * -1521134295 + EqualityComparer<string>.Default.GetHashCode(event_code);
            return hashCode;
        }

        //toString
        public override string ToString()
        {           
            return "idOption=" + idOption + ", event_code=" + event_code + ", object_id=" + object_id + ", option_text=" + option_text + ", consequence_code=" + consequence_code;
        }

    }
}
