﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.model
{
    public class Game
    {
        //attributes
        private int idGame;
        private string actual_loc;
        private string u_code; // idUser
        private string gname; 
        private int ghappiness;
        private int char_code;
        private DateTimeOffset gdatetime;

        //setters getters
        public int IdGame { get => idGame; set => idGame = value; }
        public string Actual_loc { get => actual_loc; set => actual_loc = value; }
        public string U_code { get => u_code; set => u_code = value; }
        public string Gname { get => gname; set => gname = value; }
        public int Ghappiness { get => ghappiness; set => ghappiness = value; }
        public DateTimeOffset Gdatetime { get => gdatetime; set => gdatetime = value; }
        public int Char_code { get => char_code; set => char_code = value; }

        // emptu constructor
        public Game()
        {
        }

        public Game(string gname)
        {
            this.gname = gname;
        }


        // constructor new game
        public Game( string actual_loc, string u_code, string gname,int char_code)
        {
           
            this.actual_loc = actual_loc;
            this.u_code = u_code;
            this.gname = gname;
            this.ghappiness = 0;
            this.char_code = char_code;
           
        }

        //constructor update game ( save)
        public Game(int idGame, string actual_loc, string u_code, string gname, int ghappiness, DateTimeOffset gdatetime, int char_code)
        {
            this.idGame = idGame;
            this.actual_loc = actual_loc;
            this.u_code = u_code;
            this.gname = gname;
            this.char_code = char_code;
            this.ghappiness = ghappiness;
            this.gdatetime = gdatetime;
        }

        // equals
        public override bool Equals(object obj)
        {
            return obj is Game game &&
                   idGame == game.idGame &&
                   u_code == game.u_code &&
                   gname == game.gname;
        }

        //hashcode
        public override int GetHashCode()
        {
            var hashCode = -301778013;
            hashCode = hashCode * -1521134295 + idGame.GetHashCode();
            hashCode = hashCode * -1521134295 + EqualityComparer<string>.Default.GetHashCode(u_code);
            hashCode = hashCode * -1521134295 + EqualityComparer<string>.Default.GetHashCode(gname);
            return hashCode;
        }

        //toString
        public override string ToString()
        {
            return "idGame: "+ idGame +"actual_loc: "+ actual_loc +"u_code: " + u_code +" gname: " + gname+ "ghappiness: " +ghappiness +" gdatetime: "  + gdatetime;
        }

    }
}
