﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.model
{
    public class Consequence
    {
        //attributes
        private string idConsequence;
        private string cons_desc;
        private bool game_over;
        private int reward;



        // setters and getters
        public string IdConsequence { get => idConsequence; set => idConsequence = value; }
        public string Cons_desc { get => cons_desc; set => cons_desc = value; }
        public bool Game_over { get => game_over; set => game_over = value; }
        public int Reward { get => reward; set => reward = value; }


        //constructors
        public Consequence()
        {
        }

        public Consequence(string idConsequence, string cons_desc, bool game_over, int reward)
        {
            this.idConsequence = idConsequence;
            this.cons_desc = cons_desc;
            this.game_over = game_over;
            this.reward = reward;
        }

        

        //Equals

        public override bool Equals(object obj)
        {
            return obj is Consequence consequence &&
                   idConsequence == consequence.idConsequence;
        }

        //hashcode
        public override int GetHashCode()
        {
            return 731312449 + EqualityComparer<string>.Default.GetHashCode(idConsequence);
        }


        //toString

        public override string ToString()
        {
            return "idConsequence: " + idConsequence + ", cons_desc: " + cons_desc + ", game_over: " + game_over + ", reward: " + reward;

        }
    }

}

