﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.model
{
    public class User
    {
        // attributes
        private string idUser;
        private string password;
        private int coins;
        
     
        // constructors
        public User()
        {          
        }
  
        // constructor for register
        public User(string idUser, string password)
        {
            this.idUser = idUser;
            this.password = password;
            this.coins = 0;       
        }

        //getters setters
        public string IdUser { get => idUser; set => idUser = value; }
        public string Password { get => password; set => password = value; }
        public int Coins { get => coins; set => coins = value; }
       
        //equals
        public override bool Equals(object obj) => obj is User user &&
                   idUser == user.idUser &&
                   password == user.password;

        //hashcode
        public override int GetHashCode()
        {
            return -49298373 + EqualityComparer<string>.Default.GetHashCode(idUser);
        }

        //toString
        public override string ToString()
        {
            return "idUser: " + idUser + " password: " + password +" coins: "+ coins;
        }

    }
}
